VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Wild Ideas"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   1920
      Width           =   1275
   End
   Begin VB.TextBox Text1 
      Height          =   315
      Left            =   240
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   540
      Width           =   1275
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Run Tests"
      Default         =   -1  'True
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   1140
      Width           =   1275
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Loops:"
      Height          =   195
      Left            =   240
      TabIndex        =   0
      Top             =   300
      Width           =   480
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()
   Dim Loops As Long
   Dim Results As String
   
   Loops = Val(Text1.Text)
   Results = TestAppends(Loops) & vbCrLf & _
             TestPrepends(Loops) & vbCrLf & _
             TestRemoves(Loops)
   
   Debug.Print Results
   Clipboard.Clear
   Clipboard.SetText Results
   MsgBoxOver Results, , , Me.hWnd
End Sub

Private Function TestAppends(ByVal Loops As Long) As String
   Dim i As Long
   Dim d1 As Long, d2 As Long, d3 As Long
   Dim sTmp As String
   Dim tmr As New ccrpStopWatch
   Dim sb As CStringBuilder
   Dim sRet As String
   
   ' Get loop overhead
   tmr.Reset
   For i = 1 To Loops
   Next i
   d1 = tmr.Elapsed
   
   ' Do standard appends
   tmr.Reset
   sTmp = ""
   For i = 1 To Loops
      sTmp = sTmp & (i & vbCrLf)
   Next i
   d2 = tmr.Elapsed
   
   ' Do StringBuilder appends
   tmr.Reset
   Set sb = New CStringBuilder
   For i = 1 To Loops
      sb.Append CStr(i)
      sb.Append vbCrLf
   Next i
   d3 = tmr.Elapsed
   
   sRet = "Standard Append:" & d2 - d1 & ",  " & _
          "StringBuilder Append:" & d3 - d1 & ",  " & _
          "Loops:" & Loops
   TestAppends = sRet
End Function

Private Function TestPrepends(ByVal Loops As Long) As String
   Dim i As Long
   Dim d1 As Long, d2 As Long, d3 As Long
   Dim sTmp As String
   Dim tmr As New ccrpStopWatch
   Dim sb As CStringBuilder
   Dim sRet As String
   
   ' Get loop overhead
   tmr.Reset
   For i = 1 To Loops
   Next i
   d1 = tmr.Elapsed
   
   ' Do standard prepends
   tmr.Reset
   sTmp = ""
   For i = 1 To Loops
      sTmp = (i & vbCrLf) & sTmp
   Next i
   d2 = tmr.Elapsed
   
   ' Do StringBuilder prepends
   tmr.Reset
   Set sb = New CStringBuilder
'   sb.BufferBump = 32 * 1024&
'   sb.Capacity = 64 * 1024&
   For i = 1 To Loops
      sb.Insert 0, i & vbCrLf
   Next i
   sTmp = sb.ToString
   d3 = tmr.Elapsed
   
   sRet = "Standard Prepend:" & d2 - d1 & ",  " & _
          "StringBuilder Prepend:" & d3 - d1 & ",  " & _
          "Loops:" & Loops
   TestPrepends = sRet
End Function

Private Function TestRemoves(ByVal Loops As Long) As String
   Dim i As Long
   Dim d1 As Long, d2 As Long, d3 As Long
   Dim sTmp As String
   Dim tmr As New ccrpStopWatch
   Dim sb As CStringBuilder
   Dim sRet As String
   
   ' Get loop overhead
   tmr.Reset
   For i = 1 To Loops
   Next i
   d1 = tmr.Elapsed
   
   ' Whack first char, using standard methods
   sTmp = String$(Loops, "*")
   tmr.Reset
   For i = 1 To Len(sTmp) - 1
      sTmp = Mid$(sTmp, 2)
   Next i
   d2 = tmr.Elapsed
   
   ' Whack first char, using StringBuilder
   Set sb = New CStringBuilder
   sb.Append String$(Loops, "*")
   tmr.Reset
   For i = 0 To (sb.Length - 2)
      sb.Remove 0
   Next i
   d3 = tmr.Elapsed
   
   sRet = "Standard Truncate:" & d2 - d1 & ",  " & _
          "StringBuilder Truncate:" & d3 - d1 & ",  " & _
          "Whacks:" & (Loops - 1)
   TestRemoves = sRet
End Function

Private Sub Command2_Click()
   Dim sb As CStringBuilder
   Dim i As Long
   Set sb = New CStringBuilder

'   ' Just do a reality check on the insert method
'   sb.Append String(10, "1")
'   For i = 2 To 9
'      sb.Insert i - 1, CStr(i)
'      Debug.Print sb
'   Next i

'   ' Reality check on Remove
'   For i = 0 To 9
'      sb.Append CStr(i)
'   Next i
'   For i = 0 To 9
'      sb.Remove 0, 1
'      Debug.Print "|"; sb; "|"
'   Next i
End Sub

Private Sub Form_Load()
   Text1.Text = "5000"
End Sub

